package examples.rest;

import examples.rest.pojo.CompoundObject;

import java.util.List;

import javax.ws.rs.Consumes;
import javax.ws.rs.FormParam;
import javax.ws.rs.GET;
import javax.ws.rs.PUT;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;
import javax.ws.rs.QueryParam;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.Response;

import javax.xml.bind.JAXBElement;

@Path("/users")
public class SimpleRest {
    
    @PUT
    @Path("vip")
    @Produces("application/json")
    @Consumes({
        MediaType.APPLICATION_JSON
    })
    public Response putUserVIP(CompoundObject element) {
    
          System.out.println("putUser Called"); 
          
        
            return Response.status(200).entity(  "{ \"value\" : " + 
                                               "\"" + 
                                               element.key + element.value + 
                                                "\"" +
                                               "}").build();
    
    }

    @POST
    @Path("otherwise/{year}/{month}/{day}")
    @Produces("application/json")
    public Response otherwise(
            @FormParam("name") String name,
            @FormParam("id") int id,
            @PathParam("year") int year,
            @PathParam("month") int month, 
            @PathParam("day") int day

        ) {
        
        System.out.println("year=" + year);
        System.out.println("month=" + month);
        System.out.println("day=" + day);
        
        return Response.status(200).entity("{\"value\" : " + 
                                            "\"" +
                                           year + "." + month + "." + day + "." + name + "." + id + 
                                            "\"" +
                                           "}").build();   
    }
    
    @PUT
    @Path("putTest/{year}/{month}/{day}")
    @Produces("application/json")
    @Consumes("application/json")
    public Response complexRest(
        CompoundObject obj,
        @PathParam("year") int year,
        @PathParam("month") int month, 
        @PathParam("day") int day
        
        ) {
        
        System.out.println("key=" + obj.key);
        System.out.println("value=" + obj.value);
        System.out.println("month=" + month);
        System.out.println("day=" + day);
        System.out.println("year=" + year);
        StringBuffer buf = new StringBuffer();
        
        return Response.status(200).entity("{\"value\" : " + 
                                            "\"" +
                                           year + "." + month + "." + day + "." + obj.key + "." + obj.value + 
                                            "\"" +
                                           "}").build();
    }
    
    
    @GET
    @Path("getTest/{year}/{month}/{day}")
    @Produces("application/json")
    public Response getUsers(
    
            @PathParam("year") int year,
            @PathParam("month") int month, 
            @PathParam("day") int day,    
            @QueryParam("from") int from,
            @QueryParam("to") int to,
            @QueryParam("orderBy") List<String> orderBy) 
    {
    
        return Response.status(200).entity("{\"value\" : " +
                                            "\"" +
                                           year + month + day + 
                                            "\"" +
                                           "}").build();
    
    }   
    
    
    
    
}

